## sra-sdk 3.2.1+dfsg

=== CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

cmake_minimum_required (VERSION 3.16)
if (WIN32)
    cmake_minimum_required (VERSION 3.20)
	set (CMAKE_SYSTEM_VERSION 10.0 CACHE STRING INTERNAL FORCE)
endif()

# set( CMAKE_DISABLE_SOURCE_CHANGES ON ) # Cannot use with bison
# set( CMAKE_DISABLE_IN_SOURCE_BUILD ON )

option(TOOLS_ONLY "Generate targets for tools only (else tools and tests)" ON)
option(BUILD_TOOLS_LOADERS "Generate targets for loader tools")
option(BUILD_TOOLS_INTERNAL "Generate targets for internal tools")
option(BUILD_TOOLS_TEST_TOOLS "Generate targets for test tools")
option(RUN_SANITIZER_TESTS "Run ASAN and TSAN tests" OFF)
option(NO_JAVA "Do not generate any targets that need Java" OFF)

message(CMAKE_VERSION = ${CMAKE_VERSION})

#set( CMAKE_VERBOSE_MAKEFILE ON )

# best to use at the top
project ( sra-tools )
if( PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR )
    message(FATAL_ERROR "In-source builds are not allowed")
endif()

# this has to follow the project() command!
set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    "${CMAKE_CURRENT_SOURCE_DIR}/build"
)

set( VDB_BINDIR "${CMAKE_BINARY_DIR}/../ncbi-vdb" CACHE PATH "Location of NCBI VDB build directory" )
set( VDB_INCDIR "${CMAKE_SOURCE_DIR}/../ncbi-vdb/interfaces" CACHE PATH "Location of NCBI VDB include directory" )

include(CTest)
enable_testing()
include( build/env.cmake NO_POLICY_SCOPE )

add_subdirectory( shared )
add_subdirectory( ngs )
add_subdirectory( libs )
add_subdirectory( tools )

if ( NOT TOOLS_ONLY )
    add_subdirectory( test )
endif()

set ( CPACK_PACKAGE_NAME sra-tools )
set ( CPACK_PACKAGE_VERSION 0.1 )
set ( CPACK_PACKAGE_CONTACT "sra-tools@ncbi.nlm.nih.gov" )
set ( CPACK_PACKAGE_DESCRIPTION_SUMMARY "tax payers funded SRA toolkit for scientists" )

set ( CPACK_DEBIAN_PACKAGE_ARCHITECTURE amd64 )

include ( CPack )

=== Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


TOP ?= $(shell pwd)
include $(TOP)/build/Makefile.env

=== libs/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( CMAKE_POSITION_INDEPENDENT_CODE True )
add_compile_definitions( _LIBRARY )

add_subdirectory(kxml)
add_subdirectory(loader)
add_subdirectory(vdb-sqlite)
add_subdirectory(ngs-vdb)
add_subdirectory(ascp)
add_subdirectory(diagnose)
add_subdirectory(schema)
add_subdirectory(search)

if( NOT WIN32 )
	add_subdirectory(general-writer)
endif()

=== ngs/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_subdirectory( ncbi )
add_subdirectory( ngs-sdk )
if ( Java_FOUND )
	add_subdirectory( ngs-java )
endif()
add_subdirectory( ngs-python )

=== ngs/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ..)
MODULE = ngs

include $(TOP)/build/Makefile.env

=== shared/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

add_compile_definitions( __mod__="shared" )

set( SRC toolkit.vers.c )
GenerateStaticLibs( tk-version "${SRC}" )

=== shared/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: std

TOP ?= $(abspath ..)

MODULE = shared

INT_LIBS = \
	libtk-version \

ALL_LIBS = \
	$(INT_LIBS)

ALL_TOOLS =      \
	$(INT_TOOLS) \
	$(EXT_TOOLS)
	
include $(TOP)/build/Makefile.env

#-------------------------------------------------------------------------------
# outer targets
#
all std: makedirs
	@ $(MAKE_CMD) $(TARGDIR)/std

$(INT_LIBS): makedirs
	@ $(MAKE_CMD) $(ILIBDIR)/$@


.PHONY: all std $(ALL_LIBS)

#-------------------------------------------------------------------------------
# std
#
$(TARGDIR)/std: \
	$(addprefix $(ILIBDIR)/,$(INT_LIBS))

.PHONY: $(TARGDIR)/std

#-------------------------------------------------------------------------------
# clean
#
clean: stdclean

.PHONY: clean

#-------------------------------------------------------------------------------
# toolkit-version
#
$(ILIBDIR)/libtk-version: $(addprefix $(ILIBDIR)/libtk-version.,$(ILIBEXT))

TK_VERSION_SRC = \
    toolkit.vers

TK_VERSION_OBJ = \
	$(addsuffix .$(LOBX),$(TK_VERSION_SRC))

$(ILIBDIR)/libtk-version.$(LIBX): $(TK_VERSION_OBJ)
	$(LD) --slib -o $@ $^ $(KFS_LIB)

=== test/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# this is where test executables will be created
# to access tools themselves, use ${BINDIR}
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${TESTBINDIR} )
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TESTBINDIR_DEBUG} )
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TESTBINDIR_RELEASE} )

if ( NOT SINGLE_CONFIG )
	set( COMMON_LINK_LIBRARIES ${COMMON_LINK_LIBRARIES} ktst )
else()
	set( COMMON_LINK_LIBRARIES ${COMMON_LINK_LIBRARIES} ${NCBI_VDB_LIBDIR}/libktst.${STLX} )
endif()

add_subdirectory( libs )

 #TODO: move to libs/
add_subdirectory( vdb )
add_subdirectory( schema )
add_subdirectory( search )

add_subdirectory( external )
if( BUILD_TOOLS_LOADERS )
	add_subdirectory( loaders )
endif()
if( BUILD_TOOLS_INTERNAL )
	add_subdirectory( internal )
endif()
if( BUILD_TOOLS_TEST_TOOLS )
	add_subdirectory( test-tools )
endif()

#add_subdirectory( ngs ) # moved to test/external
#add_subdirectory( align ) # moved to test/internal
#add_subdirectory( test_sanitizers ) # move to test/internal

add_subdirectory( scripts ) # move to test/internal

# add_subdirectory(samline) # command line tool; move to tools/internal

# add_subdirectory(tarballs) # called directly from TeamCity

add_subdirectory( python )

=== test/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ..)
MODULE = test

# TOOLS_ONLY=OFF
# BUILD_TOOLS_TEST_TOOLS=ON
include $(TOP)/build/Makefile.env

=== tools/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BINDIR} )

if( BUILD_TOOLS_LOADERS )
	add_subdirectory( loaders )
endif()
add_subdirectory( external )
if( BUILD_TOOLS_INTERNAL )
	add_subdirectory( internal )
endif()
if( BUILD_TOOLS_TEST_TOOLS )
	add_subdirectory( test-tools )
endif()

=== tools/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ..)
MODULE = tools

include $(TOP)/build/Makefile.env

=== build/docker/Makefile ===
# Make file for building SRA Toolkit docker image

ifndef VERSION
$(error VERSION needs to be set, e.g. make VERSION=2.11.1 build)
endif

DOCKER_ARCH := $(shell docker info | perl -ne'print "$$1\n" if /Architecture:\s*(\w+)/')
BRANCH?=${VERSION}rc
REPO=ncbi/sra-tools
TAG=${DOCKER_ARCH}-${VERSION}

.DEFAULT: build
.PHONY: build buildx push manifest clean test help

help:
	@ echo "targets are: build, test, push, manifest, and clean"

build:
	docker pull alpine:latest
	docker build --build-arg VDB_BRANCH=${BRANCH} --tag ${REPO}:${TAG} -f Dockerfile.build-alpine .

test:
	docker run -it --rm ${REPO}:${TAG} fastq-dump -X 5 -Z SRR000001

push:
	docker push ${REPO}:${TAG}
	@ echo Remember to make VERSION=${VERSION} manifest once all the images are built.

manifest:
	# Need to remove any old manifests with the same tags we are creating
	docker manifest rm ${REPO}:latest || true
	docker manifest rm ${REPO}:${VERSION} || true
	docker manifest create ${REPO}:${VERSION} $(shell perl find-parts.pl ${VERSION})
	docker manifest push ${REPO}:${VERSION}
	docker manifest create ${REPO}:latest ${REPO}:x86_64-${VERSION} ${REPO}:aarch64-${VERSION}
	docker manifest push ${REPO}:latest

clean:
	docker image rm ${REPO}:${TAG}
	docker manifest rm ${REPO}:latest
	docker manifest rm ${REPO}:${VERSION}

buildx:
	docker build \
	    --platform=linux/amd64,linux/arm64 \
	    --build-arg VDB_BRANCH=${BRANCH} \
	    --tag ${REPO}:${VERSION} \
	    --tag ${REPO}:latest \
	    --file Dockerfile.build-alpine \
	    --pull \
	    --push \
	    .

=== debian/changelog ===
sra-sdk (3.2.1+dfsg-6ubuntu1) resolute; urgency=medium

  * Merge with Debian; remaining changes:
    - Disable LTO; this causes a misbuild that makes fastq-dump segfault.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 28 Feb 2026 08:42:51 +0100

sra-sdk (3.2.1+dfsg-6) unstable; urgency=medium

  * debian/control: Build-depend on pkgconf.
  * debian/patches/support_glibc_2.43.patch (new): Comment out
    test/search/agrep-main.c's gratuitous redefinition of index as an alias
    for strchr, which interacted poorly with C23 const-preserving generics.
    (Closes: #1128753.)
  * debian/patches/support_libre2-11.patch: Obtain re2's dependencies from
    pkgconf rather than hardcoding absl_string_view.  (Closes: #1126172,
    modulo the need for a rebuilt re2.)
  * Update watch file format version to 5.
  * Add dversionmangle for repack versioning in debian/watch.
  * Use GitHub template in watch file instead of explicit
    Source/Matching-Pattern.
  * Reorder Files paragraphs in debian/copyright by directory depth.
  * Remove duplicate values for fields Entry, Entry, Entry, Name, Name in
    debian/upstream/metadata.
  * debputy lint --auto-fix (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 27 Feb 2026 17:45:36 -0500

sra-sdk (3.2.1+dfsg-5) unstable; urgency=medium

  * debian/patches/bypass-libxml2-ATTRIBUTE_UNUSED.patch (new): Fix builds
    with libxml2 2.14+, which don't define ATTRIBUTE_UNUSED publically.
    (Closes: #1106622.)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 16 Aug 2025 23:39:09 -0400

sra-sdk (3.2.1+dfsg-4ubuntu6) resolute; urgency=medium

  * No-change rebuild for abseil soname.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 Jan 2026 08:55:23 +0100

sra-sdk (3.2.1+dfsg-4ubuntu5) questing; urgency=medium

  * Fix build with libxml 2.14.x.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 28 May 2025 14:27:42 +0200

sra-sdk (3.2.1+dfsg-4ubuntu4) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 26 May 2025 14:23:23 +0200

sra-sdk (3.2.1+dfsg-4ubuntu3) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 May 2025 12:19:57 +0200

sra-sdk (3.2.1+dfsg-4ubuntu2) questing; urgency=medium

  * Rebuild against latest abseil

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 03 May 2025 11:13:20 -0400

sra-sdk (3.2.1+dfsg-4ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO; this causes a misbuild that makes fastq-dump segfault.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 17 Apr 2025 09:58:24 +0200

sra-sdk (3.2.1+dfsg-4) unstable; urgency=medium

  * debian/patches: Add two patches for GCC 15 support.  (Closes: #1097930.)
    - fix_bm_for_gcc15.patch: BitMagic cherry-pick, location adjusted.
    - include_cstdint_for_gcc15.patch: Compensate for libstdc++ changes.
  * debian/rules: Explicitly direct pybuild to use distutils.  It can
    otherwise misfire when bypassing the test suite, which includes a
    setup.py run.  (Closes: #1103330.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 16 Apr 2025 15:44:48 -0400

sra-sdk (3.2.1+dfsg-3ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO; this causes a misbuild that makes fastq-dump segfault.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 10 Apr 2025 17:12:28 +0200

sra-sdk (3.2.1+dfsg-3) unstable; urgency=medium

  * Upload to unstable.
  * debian/salsa-ci.yml: Disable use of experimental (build-)deps again.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 09 Apr 2025 21:31:32 -0400

sra-sdk (3.2.1+dfsg-2) experimental; urgency=medium

  * debian/control: Build-depend on python3-setuptools.
  * debian/patches/fix_arm64_build.patch: Correct parenthesis placement.
  * debian/patches/setuptools.patch (new): Substitute setuptools for
    distutils (retired) in ngs/ngs-python/setup.py.
  * debian/rules:
    - Set PIP_BREAK_SYSTEM_PACKAGES for upstream's test suite.
    - Substitute pybuild for direct setup.py invocation and clean up after
      it.
  * .gitignore: Add .pc (belatedly) and .pybuild.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 09 Apr 2025 20:41:31 -0400

sra-sdk (3.2.1+dfsg-1) experimental; urgency=medium

  [ Andreas Tille ]
  * New upstream version 3.1.1.
  * Fix Python3.12 string syntax
    Closes: #1087096
  * Do not fail if clean target debian/libngs-jni.links does not exist

  [ Aaron M. Ucko ]
  * New upstream version 3.2.1.
  * debian/control:
    - Tighten libncbi-vdb-dev build dependency as usual; add one on
      python3-vdb (provided by ncbi-vdb-data for now, to be split off
      post-Trixie.)
    - Drop vestigial build dependency on libfuse-dev.  (Closes: #1084404.)
  * debian/copyright: Update GPL logistics (see #1080497) and bm and
    spdlog paths.
  * debian/patches: Update accordingly.  Notably:
    - label_online_tests.patch: Add a couple dozen additional tests.
    - missing_include.patch: Drop, superfluous at this point.
    - support_libre2-11.patch: Cover new additions to
      fastq_defline_matcher.hpp.
    - use_debian_packaged_re2.patch: Cover new test-sharq-reader.
  * debian/rules:
    - Stop generating and installing debian.kfg, taken over by
      ncbi-vdb-data.
    - Clean up additional build output.
  * debian/salsa-ci.yml: Reenable use of experimental (build-)deps for now.
  * debian/tests/control: Per Stefano Rivera (thanks!), declare a
    dependency on ca-certificates and the need for Internet access.
    (Closes: #1099933.)
  * .gitignore: Add, belatedly.
  * Standards-Version: 4.7.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 08 Apr 2025 21:51:58 -0400

sra-sdk (3.0.9+dfsg-7.1ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable LTO; this causes a misbuild that makes fastq-dump segfault.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Mar 2025 08:31:47 +0100



=== debian/control ===
Source: sra-sdk
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               dh-python,
               javahelper,
	       libabsl-dev,
               libncbi-vdb-dev (>= 3.2.1+dfsg~),
               libhdf5-dev,
               libmagic-dev,
               libre2-dev,
               libxml2-dev,
               libzstd-dev,
               liblzma-dev,
               libsam-extract-dev,
               maven-repo-helper,
               pkgconf,
               python3-all,
               python3-setuptools,
               python3-vdb,
               default-jdk,
               flex,
               bison
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/
Rules-Requires-Root: no

Package: sra-toolkit
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 Other tools distributed in this package are:
  abi-dump, abi-load
  align-info
  bam-load
  cache-mgr
  cg-load
  copycat
  fasterq-dump
  fastq-dump, fastq-load
  helicos-load
  illumina-dump, illumina-load
  kar
  kdbmeta
  latf-load
  pacbio-load
  prefetch
  rcexplain
  remote-fuser
  sff-dump, sff-load
  sra-pileup, sra-sort, sra-stat, srapath
  srf-load
  test-sra
  vdb-config, vdb-copy, vdb-decrypt, vdb-encrypt, vdb-get, vdb-lock,
  vdb-passwd, vdb-unlock, vdb-validate
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

Package: libngs-c++3
Multi-Arch: same
Architecture: amd64 arm64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (C++ runtime)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libngs-c++-dev
Multi-Arch: same
Architecture: amd64 arm64
Section: libdevel
Depends: ${misc:Depends},
         libngs-c++3 (= ${binary:Version})
Breaks: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
Replaces: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
Description: Next Generation Sequencing language Bindings (C++ development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the development package for C++ usage.

Package: libncbi-ngs3
Multi-Arch: same
Architecture: amd64 arm64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (full runtime)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-ngs-dev
Multi-Arch: same
Architecture: amd64 arm64
Section: libdevel
Depends: ${misc:Depends},
         libncbi-ngs3 (= ${binary:Version}),
         libngs-c++-dev (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (C++ development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the full development package.

Package: libngs-java
Multi-Arch: same
Architecture: amd64 arm64
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         libngs-jni (>= ${source:Version}),
         libngs-jni (<< ${source:Version}.1~)
Recommends: ${java:Recommends}
Suggests: libngs-java-doc
Description: Next Generation Sequencing language Bindings (Java bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java bindings.

Package: libngs-jni
Multi-Arch: same
Architecture: amd64 arm64
Section: java
Depends: ${shlibs:Depends},
         libncbi-ngs3 (= ${binary:Version}),
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (Java native binding)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java native bindings.

Package: libngs-java-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Next Generation Sequencing language Bindings (Java documentation)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Documentation for the Java bindings.

Package: python3-ngs
Architecture: all
Section: python
Depends: ${python3:Depends},
         ${misc:Depends},
         libncbi-ngs3 (>= ${source:Version}),
         libncbi-ngs3 (<< ${source:Version}.1~)
Description: Next Generation Sequencing language Bindings (Python3 bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

# Pregenerated with uuidgen -r
DEBIAN_GUID = 806b5c3b-0088-4732-8359-51630950d723

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto

export DEB_CFLAGS_MAINT_APPEND   = -fsigned-char
export DEB_CXXFLAGS_MAINT_APPEND = -fsigned-char

export PIP_BREAK_SYSTEM_PACKAGES = 1

pkg := sra-toolkit

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ --buildsystem=cmake \
	    --with python3,javahelper,jh_maven_repo_helper

OUTDIR=$(CURDIR)/debian/tmp

override_dh_auto_clean:
	dh_auto_clean
	rm -rf ngs/ngs-java/$(DEB_HOST_MULTIARCH)
	rm -rf ngs/ngs-bam/$(DEB_HOST_MULTIARCH)
	rm -f ngs/ngs-bam/Makefile.config
	rm -f ngs/ngs-bam/Makefile.config.install.linux.x86_64.prl
	rm -f ngs/ngs-bam/Makefile.config.linux.x86_64
	rm -f ngs/ngs-bam/reconfigure
	rm -rf ngs/ngs-sdk/ngs/unix/generic

	rm -rf ngs/ngs-sdk/$(DEB_HOST_MULTIARCH)
	rm -rf ngs/ngs-python/build ngs/ngs-python/dist
	rm -rf ngs/ngs-python/ngs.egg-info

	find test tools -name actual -type d | xargs -rt rm -rf
	rm -rf ngs/ngs-*/examples/actual/*
	rm -fv test/*/*/tmp.kfg
	rm -rf libs/general-writer/test/actual
	rm -rf libs/ngs-vdb/test/data/SparseFragmentBlobs
	rm -rf test/external/vdb-dump/db test/loaders/bam-load/out.sra
	rm -rf test/schema/test_*.db test/vdb/db
	find tools/loaders/general-loader/test -name input | xargs -rt rm -rf
	rm -f ngs/ngs-sdk/examples/actual.txt

	-rm -f debian/libngs-jni.links
	rm -rf .pybuild

override_dh_auto_configure:
	dh_auto_configure -- -DVDB_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} \
	    -DVDB_INCDIR=/usr/include/ncbi-vdb -DBUILD_TOOLS_LOADERS=ON \
	    -DBUILD_TOOLS_INTERNAL=ON -DBUILD_TOOLS_TEST_TOOLS=ON \
	    -DCMAKE_SKIP_RPATH=ON -DTOOLS_ONLY=OFF \
	    -DCOMPILER_OPTION_SSE42_SUPPORTED=FALSE

KFG_INC  = /usr/include/ncbi-vdb/kfg/ncbi
KFG_DEST = debian/sra-toolkit/etc/ncbi
override_dh_auto_install:
	dh_auto_install
	# build/install.sh $(KFG_INC) \
	# 		 $(CURDIR)/tools/internal/vdb-copy \
	# 		 $(KFG_DEST) \
	# 		 $(KFG_DEST) \
	# 		 debian/sra-toolkit/usr/bin \
	# 		 debian/sra-toolkit/usr/lib/$(DEB_HOST_MULTIARCH) \
	# 		 $(CURDIR)/shared/kfgsums
	build/install-kfg.sh default.kfg $(KFG_INC) $(KFG_DEST) \
			     $(KFG_INC)/kfgsums
	build/install-kfg.sh certs.kfg $(KFG_INC) $(KFG_DEST) \
			     $(KFG_INC)/kfgsums
	build/install-kfg.sh vdb-copy.kfg $(CURDIR)/tools/internal/vdb-copy \
			     $(KFG_DEST) $(CURDIR)/shared/kfgsums
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libncbi-ngs.a*" \
			usr/lib/$(DEB_HOST_MULTIARCH) \
		    --override "s/libncbi-vdb3-dev/libncbi-vdb-dev/" \
		    debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libncbi-ngs.so
# Ignore spurious failures from pluses; --ignorelibdep only partially helps.
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/lib*c++.a*" \
			usr/lib/$(DEB_HOST_MULTIARCH) \
		    --movedev "debian/tmp/usr/include/*" usr/include \
		    --ignorelibdep \
		    debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libngs-c++.so | \
		tee /dev/stderr | LC_ALL=C grep '^[a-z]' | sh

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	for d in debian/lib*-dev/usr/lib/$(DEB_HOST_MULTIARCH) ; do \
	    for slib in $$d/lib*.a ; do \
		mv $$d/`readlink $$slib` $$slib ; \
		mv $$d/`readlink $$slib` $$slib ; \
	    done ; \
	done
	ls -l debian/tmp/usr/bin
	cd debian/tmp/usr/bin && \
	for bin in *-orig.* ; do \
	    base=$${bin%-orig.*} && \
	    vbase=$$(readlink "$$(readlink $$base)") && \
	    vdriver=$$(readlink "$$vbase") && \
	    mv -v $$bin $$base-orig && \
	    ln -snfv $${vdriver%%.[0-9]*} $$vbase || exit $$? ; \
	done && \
	for bin in *[a-z+] ; do \
	    bin2=$$(readlink $$bin) ; \
	    bin3=$$(readlink "$$bin2") ; \
	    case $$bin2 in \
	        $$bin.* ) rm -v $$bin2 && mv -v $$bin3 $$bin || exit $$? ;; \
	    esac ; \
	done
	mkdir debian/tmp/usr/lib/sra-toolkit
	mv debian/tmp/usr/bin/sratools debian/tmp/usr/lib/sra-toolkit
	for x in debian/tmp/usr/bin/*-orig; do \
	    mv -v $$x debian/tmp/usr/lib/sra-toolkit ; \
	    ln -snfv ../lib/sra-toolkit/sratools $${x%-orig} ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	pybuild --install --name ngs -d ngs/ngs-python -s distutils

override_dh_installexamples:
	dh_installexamples
	find debian/*/ -name .gitignore -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-$(DEB_HOST_MULTIARCH)  && \
	    ctest --force-new-ctest-process --verbose -j1 -LE online
endif

override_dh_prep:
	dh_prep -X debian/tmp

execute_before_dh_link:
	# Putting the upstream version number (without the dfsg part) at the end of
	# symlink source in the -jni package.
	sed -e 's/\(#STRIPPED_UPSTREAM_VERSION#\)/\1$(DEB_VERSION_UPSTREAM)/' \
	    -e 's/#STRIPPED_UPSTREAM_VERSION#\(.*\)+dfsg[0-9]*/\1/' \
	    -e 's/\$$[({]DEB_HOST_MULTIARCH[)}]/$(DEB_HOST_MULTIARCH)/g' \
	    debian/libngs-jni.links.in > debian/libngs-jni.links

# require network, not automatically run
# use it when the pom file must be re-downloaded from maven repo
BASE_URL:=https://repo.maven.apache.org/maven2/gov/nih/nlm/ncbi/ngs-java
WGET=wget --no-clobber
get-poms:
	$(RM) debian/ngs-java.pom debian/ngs-java.pom.asc
	# extract upstream version
	$(WGET) -O debian/ngs-java.pom $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom && \
	$(WGET) -O debian/ngs-java.pom.asc $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom.asc
	gpg --trust-model=always --status-fd 1 --no-default-keyring --keyring debian/sra-tools.gpg --verify debian/ngs-java.pom.asc

=== debian/watch ===
Version: 5

Repack-Suffix: +dfsg
Debian-Version-Mangle: s/\+dfsg//g
Compression: xz
Filename-Mangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%
Dversion-Mangle: s/\+(dfsg|ds|debian|repack)(\d*)$//
Template: GitHub
Owner: ncbi
Project: sra-tools
